from functools import partial

products = {
    "apple": {"price": 2.0, "stock": 50},
    "bread": {"price": 3.5, "stock": 30},
    "milk": {"price": 4.0, "stock": 20},
    "chocolate": {"price": 1.5, "stock": 40}
}

discounts = {
    "apple": lambda x: x // 3 * 2 + (x % 3),
    "milk": lambda x: x * 0.8
}

cart = {
    "apple": 8,
    "bread": 30,
    "milk": 10
}

template = "{:<4}{:<15}{:>8}{:>7}"

table = lambda h1, h2, d, f1, f2: "\n".join([template.format("", "Name", h1, h2)] + [template.format(f"{i + 1}.", k.title(), f1(k, v), f2(k, v)) for i, (k, v) in enumerate(d.items())])

list_products = lambda: table("Price", "Stock", products, lambda k, v: v["price"], lambda k, v: v["stock"])

list_cart = lambda: table("Quantity", "Total", cart, lambda k, v: v, lambda k, v: products[k]["price"] * v)

total = lambda: (lambda x, y: "\n".join([template.format("", "Name", "Quantity", "Total")] + list(x) + [f"Total:{sum(y):28}"] + ([f"With discount:{sum(y) * 0.9:>20}"] if sum(y) > 100 else [])))(*zip(*[(template.format(f"{i + 1}.", k.title(), v, products[k]["price"] * v) + (f"\n    Discount applied:{products[k]["price"] * (discounts[k](v) - v):>13}" if k in discounts else ""), products[k]["price"] * discounts.get(k, lambda x: x)(v)) for i, (k, v) in enumerate(cart.items())]))

#separate input and print from the logic
def select(max_, prompt, action):
    i = input(prompt)
    if i.isdigit() and 0 <= int(i) and int(i) <= max_:
        if i != "0":
            action(int(i))
    else:
        print("Invalid input")
        select(max_, prompt, action)

select_menu = lambda list_, dic, action: (f"{list_()}\n0.  Cancel", lambda: select(len(dic), "Select: ", lambda i: action(list(dic)[i - 1])))

menu = {
    "List products": lambda: (list_products(),),
    "Add item": lambda: select_menu(list_products, products, lambda p: select(products[p]["stock"] - cart.get(p, 2), "Quantity: ", lambda q: cart.update({p: cart.get(p, 0) + q}))),
    "Remove item": lambda: select_menu(list_cart, cart, lambda p: cart.pop(p)),
    "View cart": lambda: (total(),),
    "Exit": exit
}

while True:
    for i, o in enumerate(menu):
        print(f"{i + 1}.  {o}")
    p, *f = list(menu.values())[int(input("Select: ")) - 1]()
    print()
    print(p)
    if f:
        f[0]()
    print()
